﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BubbleSmash
{
    public partial class Form1 : Form
    {
        private int numCandies = 10;
        private Array shapes = Enum.GetValues(typeof(C1.Win.C1Chart.SymbolShapeEnum));
        private int nScore = 0;
        private int nTime = 100;
        private int nHits = 0;
        private int nLosts = 0;

        private Random xPosRandom = new Random();
        private Random colorRandom = new Random();
        private Random shapeRandom = new Random();
        private Random wordRandom = new Random();
        private int count = 2;

        int saveTimer = 0;
        int saveHits, saveLost, saveScore;
        bool flag;
        public Form1()
        {
            InitializeComponent();
            //this.Icon = Icon.
        }


        private void SetStatusLabel()
        {
            string label = string.Format("Score: {0}  Hits: {1}  Lost: {2} Time: {3}", nScore, nHits, nLosts, nTime);
            c1Chart1.Header.Text = label;
        }

        private void InitChart()
        {
            c1Chart1.ChartArea.Style.Opaque = false;
            c1Chart1.BackColor = Color.Black;
            c1Chart1.ChartArea.Margins.Left = 0;
            c1Chart1.ChartArea.Margins.Top = 0;
            c1Chart1.ChartArea.Margins.Right = 0;
            c1Chart1.ChartArea.Margins.Bottom = 0;
            c1Chart1.BorderStyle = BorderStyle.Fixed3D;

            c1Chart1.ChartArea.Style.BackColor = Color.SkyBlue;
            c1Chart1.ChartArea.Style.BackColor2 = Color.PaleGreen;
            c1Chart1.ChartArea.Style.GradientStyle = C1.Win.C1Chart.GradientStyleEnum.Vertical;
            c1Chart1.ChartArea.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.None;
            c1Chart1.ChartArea.Style.Border.Thickness = 0;
            
            // Setup the Header
            c1Chart1.Header.Compass = C1.Win.C1Chart.CompassEnum.North;
            c1Chart1.Header.Style.Font = new Font("Courier New", 12, FontStyle.Bold);
            c1Chart1.Header.Style.ForeColor = Color.Lime;
            //c1Chart1.Header.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.RaisedBevel;
            c1Chart1.Header.Style.Border.Thickness = 2;
            c1Chart1.Header.Visible = true;
            SetStatusLabel();

            // Setup the Axis X
            C1.Win.C1Chart.Axis xa = c1Chart1.ChartArea.AxisX;
            xa.AutoMax = false;
            xa.AutoMin = false;
            xa.AutoMajor = false;
            xa.AutoMinor = false;
            xa.GridMajor.Visible = false;
            xa.GridMinor.Visible = false;
            xa.Min = 0;
            xa.Max = 100;
            xa.TickMajor = C1.Win.C1Chart.TickMarksEnum.None;
            xa.TickMinor = C1.Win.C1Chart.TickMarksEnum.None;
            xa.TickLabels = C1.Win.C1Chart.TickLabelsEnum.None;
            xa.Thickness = 1;
            xa.Visible = false;

            // Setup the Axis Y
            C1.Win.C1Chart.Axis ya = c1Chart1.ChartArea.AxisY;
            ya.AutoMax = false;
            ya.AutoMin = false;
            ya.AutoMajor = false;
            ya.AutoMinor = false;
            ya.GridMajor.Visible = false;
            ya.GridMinor.Visible = false;
            ya.Min = 0;
            ya.Max = 100;
            ya.TickMajor = C1.Win.C1Chart.TickMarksEnum.None;
            ya.TickMinor = C1.Win.C1Chart.TickMarksEnum.None;
            ya.TickLabels = C1.Win.C1Chart.TickLabelsEnum.None;
            ya.Thickness = 1;
            ya.Visible = false;

            // Setup the Axis Y2
            C1.Win.C1Chart.Axis y2a = c1Chart1.ChartArea.AxisY2;
            y2a.AutoMax = false;
            y2a.AutoMin = false;
            y2a.AutoMajor = false;
            y2a.AutoMinor = false;
            y2a.Min = 0;
            y2a.Max = 100;
            y2a.TickMajor = C1.Win.C1Chart.TickMarksEnum.None;
            y2a.TickMinor = C1.Win.C1Chart.TickMarksEnum.None;
            y2a.TickLabels = C1.Win.C1Chart.TickLabelsEnum.None;
            y2a.Visible = false;

            //c1Chart1.ChartArea.PlotArea.Boxed = false;

            // Set the Group 0 to Bubble Chart
            C1.Win.C1Chart.ChartGroup group0 = c1Chart1.ChartGroups.Group0;
            group0.ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Bubble;
            group0.Bubble.MaximumSize = 10;
            group0.Bubble.MinimumSize = 3;

            group0.ChartData.SeriesList.RemoveAll();

            c1Chart1.ChartArea.Style.Opaque = false;
            c1Chart1.BackgroundImage = Image.FromFile("..\\..\\images\\ChristmasTheme.jpg");
            c1Chart1.BackgroundImageLayout = ImageLayout.Stretch;
            
        }
        
        private void Play()
        {
            flag = true;
            if (saveTimer > 0)
            {
                nTime = saveTimer;
            }
            else
            {
                nTime = 100;
            }
            

            stepTimer.Start();
        }
        private void StopGame()
        {
            flag = false;
            stepTimer.Stop();
        }


        
        private void Form1_Load(object sender, EventArgs e)
        {
            InitChart();
        }
        private void stepTimer_Tick(object sender, EventArgs e)
        {
            this.stepTimer.Stop();
            nTime--;
            if (nTime < 0)
            {
                StopGame();
                //Display Score
                DisplayScore ds = new DisplayScore();
                ds.updateScore(nHits.ToString(), nLosts.ToString(), nScore.ToString());
                ds.ShowDialog();
                return;
            }
            // A candy goes out of the region
            int i = 0;
            for (int index = 0; index < c1Chart1.ChartGroups[0].ChartData.SeriesList.Count; index++)
            {
                C1.Win.C1Chart.ChartDataSeries series = c1Chart1.ChartGroups[0].ChartData.SeriesList[index];
                series.Y[0] = (int)series.Y[0] + 10;

                if ((int)series.Y[0] > 100)
                {
                    c1Chart1.ChartGroups[0].ChartData.SeriesList.Remove(series);


                    nLosts++;
                    break;
                }

                series.Y1[0] = (int)series.Y[0] / 20;
                i++;
            }
            // It is time to give a new candy
            if (count >= 10 / this.numCandies)
            {
                count = 0;

                C1.Win.C1Chart.ChartDataSeries series = this.c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                series.SymbolStyle.Shape = C1.Win.C1Chart.SymbolShapeEnum.Dot;
                series.FillStyle.GradientStyle = C1.Win.C1Chart.GradientStyleEnum.Radial; ;
                series.FillStyle.Color1 = Color.FromArgb(xPosRandom.Next(0, 255), xPosRandom.Next(0, 255), xPosRandom.Next(0, 255));
                series.FillStyle.Color2 = Color.FromArgb(xPosRandom.Next(0, 255), xPosRandom.Next(0, 255), xPosRandom.Next(0, 255));
                series.Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;

                series.X.Length = 1;
                series.Y.Length = 1;
                series.Y1.Length = 1;
                series.X[0] = xPosRandom.Next(10, 90);
                series.Y[0] = 10;
                series.Y1[0] = (int)series.Y[0] / 20;

            }
            else
                count++;
            SetStatusLabel();
            this.stepTimer.Start();
        }

        private void c1Chart1_MouseDown(object sender, MouseEventArgs e)
        {
            if (flag)
            {
                int s = 0, d = 0, p = 0, index = 0;
                C1.Win.C1Chart.ChartRegionEnum region = c1Chart1.ChartRegionFromCoord(e.X, e.Y);
                c1Chart1.ChartGroups[0].CoordToDataIndex(e.X, e.Y, C1.Win.C1Chart.CoordinateFocusEnum.XandYCoord, ref s, ref p, ref d);
                if (d < 20 && s > -1 && p > -1)
                {
                    C1.Win.C1Chart.ChartDataSeries series = c1Chart1.ChartGroups[0].ChartData.SeriesList[index];
                    nScore += 100 - (int)series.Y[0];
                    c1Chart1.ChartGroups[0].ChartData.SeriesList.RemoveAt(s);
                    nHits++;
                }
                SetStatusLabel();
            }
        }
        private void btn_Resume_Click(object sender, EventArgs e)
        {
            nHits = saveHits;
            nLosts = saveLost;
            nScore = saveScore;
            nTime = saveTimer;
            SetStatusLabel();
            Play();
            
        }
        private void btn_Pause_Click(object sender, EventArgs e)
        {
            saveHits = nHits;
            saveLost = nLosts;
            saveScore = nScore;
            saveTimer = nTime;
            SetStatusLabel();
            StopGame();
            
        }
        private void btn_Stop_Click(object sender, EventArgs e)
        {
            //c1Chart1.Reset();
            nHits = 0;
            nLosts = 0;
            nScore = 0;
            nTime = 100;
            SetStatusLabel();
            StopGame();
            InitChart();
        }
    }
}
